# std::fclose

From cppreference.com
< cpp‎ | io‎ | c

Defined in header `<cstdio>` |  |
int fclose( std::FILE* stream ); |  |

Closes the given file stream. Any unwritten buffered data are flushed to the OS. Any unread buffered data are discarded.

Whether or not the operation succeeds, the stream is no longer associated with a file, and the buffer allocated by std::setbuf or std::setvbuf, if any, is also disassociated and deallocated if automatic allocation was used.

The behavior is undefined if the value of the pointer `stream` is used after `fclose` returns.

### Parameters

stream | - | the file stream to close

### Return value

​0​ on success, EOF otherwise

### Example

Run this code

    #include <cstdio>
    #include <cstdlib>

    int main()
    {
        FILE* fp = std::fopen("test.txt", "r");
        if(!fp) {
            std::perror("File opening failed");
            return EXIT_FAILURE;
        }

        int c; // note: int, not char, required to handle EOF
        while ((c = std::fgetc(fp)) != EOF) { // standard C I/O file reading loop
           std::putchar(c);
        }

        if (std::ferror(fp))
            std::puts("I/O error when reading");
        else if (std::feof(fp))
            std::puts("End of file reached successfully");

        std::fclose(fp);
    }

### See also

fopen | opens a file (function)
freopen | open an existing stream with a different name (function)
close | flushes the put area buffer and closes the associated file (public member function of `std::basic_filebuf<CharT,Traits>`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/io/c/fclose&oldid=84360"